package tomcat_jk.servlet;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletException;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;
import java.lang.reflect.Method;
import java.lang.reflect.InvocationTargetException;
/**
 *  NGXgɊւ\T[ubgłB
 */
public class ServletInfoServlet extends HttpServlet {
  public void doGet(HttpServletRequest request,
    HttpServletResponse response)
      throws IOException, ServletException {
    
    response.setContentType("text/html; charset=Windows-31J");
    PrintWriter out = response.getWriter();
    
    out.println("<html>");
    out.println("<head><title>T[ubg</title></head>");
    out.println("<body bgcolor=white>");
    out.println("<table>");
    
    out.println("<tr><th bgcolor=yellow>Servlet</th>");
    out.println("<td></td></tr>");
    
    // T[ubg̏
    showRequestHeader("ContextPath", request, out);
    showRequestHeader("RequestURI", request, out);
    showRequestHeader("ServletPath", request, out);
    showRequestHeader("PathInfo", request, out);
    showRequestHeader("QueryString", request, out);
    
    out.println("<tr><th bgcolor=yellow>Request</th>");
    out.println("<td></td></tr>");
    
    // NGXgwb_̏
    showRequestHeader("RemoteAddr", request, out);
    showRequestHeader("RemoteHost", request, out);
    showRequestHeader("ServerName", request, out);
    showRequestHeader("Protocol", request, out);
    showRequestHeader("ContentType", request, out);
    
    out.println("<tr><th bgcolor=yellow>HTTP</th>");
    out.println("<td></td></tr>");
    
    // ȊÕNGXgwb_̏
    Enumeration headers = request.getHeaderNames();
    String header;
    while (headers.hasMoreElements()) {
      header = (String)headers.nextElement();
      out.println("<tr>");
      out.println("<th bgcolor=lightblue>" + header + "</th>");
      out.println("<td>" + request.getHeader(header) + "</td>");
      out.println("</tr>");
    }
    
    out.println("</table>");
    out.println("</body>");
    out.println("</html>");
  }
  
  private void showRequestHeader(String name,
    HttpServletRequest request, PrintWriter out) {
    out.println("<tr>");
    out.println("<th bgcolor=lightblue>" + name + "</th>");
    out.print("<td>");
    try {
      Class target = Class.forName(
        "javax.servlet.http.HttpServletRequest");
      Method getter = target.getMethod("get" + name, null);
      String property = (String)getter.invoke(request, null);
      out.print(property);
    } catch (Exception e) {
      e.printStackTrace(out);
    } finally {
      out.println("</td>");
      out.println("</tr>");
    }
  }
}
